function GetTime(time_ms)
	local mm = math.floor(time_ms / 60000)
	local ss = math.floor((time_ms % 60000) / 1000)
	local ms = math.floor((time_ms % 60000) % 1000)

	return string.format('%d:%02d.%03d', mm, ss, ms)
end

function Lua_GetBoolen(boolen_value)
	if boolen_value == true then
		return 1
	elseif boolen_value == false then
		return 0
	else
		return boolen_value
	end
end
-----------------------------------------------------------------------------------------------_currentDriverInfo---
_currentDriverInfo = {
	setCurrentDriver = function(self, current_driver_id)
		self.CurrentDriver = StateGarage:GetDriverInfoByID(current_driver_id)
		--skill1
		self.Skill1 = StateGarage:GetSkillInfo(self.CurrentDriver.mSkill1)
		self.Skill2 = StateGarage:GetSkillInfo(self.CurrentDriver.mSkill2)
		self.Skill3 = StateGarage:GetSkillInfo(self.CurrentDriver.mSkill3)
	end,
	
	setPrice = function(self, component_name)
		SetPrice(component_name, 'P', self.CurrentDriver.mCoin, self.CurrentDriver.mRealMoney, 0)
	end,
}

function _currentDriverInfo:new()
	local obj = {
		CurrentDriver,
		Skill1,
		Skill2,
		Skill3,
	}
	setmetatable(obj, self)
	self._index = self
	return obj
end
---_currentDriverInfo-----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------_uiComponentDisplay---
_uiComponentDisplay = {
	--set component name
	setCName 			= function (self, c_name)
		self.CName = c_name
	end,
	--set show flag
	setDFlag 			= function (self, display_flag)
		self.DFlag = display_flag
	end,
	--set enable flag
	setEFlag 			= function (self, enable_flag)
		self.EFlag = enable_flag
	end,
	--set show ani
	setShowAni 			= function (self, ui_show_animation)
		self.ShowAni = ui_show_animation
	end,
	--set show animation delay
	setShowAniDelay 	= function (self, delay_show)
		self.ShowAniDelay = delay_show
	end,
	--set hide ani
	setHideAni 			= function (self, ui_hide_animation)
		self.HideAni = ui_hide_animation	
	end,
	--set hide animation delay
	setHideAniDelay	 	= function (self, delay_hide)
		self.HideAniDelay = delay_hide	
	end
}

function _uiComponentDisplay:new()
	local obj = {
		--component object
		CName,
		--is show
		DFlag			= false,
		--is enable
		EFlag 			= true,
		--show animation
		ShowAni 		= 'ui_ani_show_default',
		--show animation delay
		ShowAniDelay 	= 300,
		--hide animation
		HideAni 		= 'ui_ani_hide_default',
		--hide animation delay
		HideAniDelay 	= 100,
	}
	setmetatable(obj, self)
	self._index = self
	return obj
end
---_uiComponentDisplay----------------------------------------------------------------------------------------------
function SetPrice(component_name, price_tag_t, ...)--(component_name, price_tag, coin, realmoney, [rmb])
	local arguments = {...}
	local price_tag = price_tag_t
	local churrency = 'C'
	local price = 0
	local churrency_mark = {'C', 'G', 'Y'}

	for v in ipairs(arguments) do
		if arguments[v] ~= 0 then
			price = arguments[v]
			churrency = churrency_mark[v]
		end
	end
	
	SetComponentText(component_name, price_tag .. churrency .. price)
end

function GetPrice(...)--(coin, realmoney, [rmb])
	local arguments = {...}
	local price = 0

	for v in ipairs(arguments) do
		if arguments[v] ~= 0 then
			price = arguments[v]
		end
	end
	
	return price
end

function GetChurrency(...)--(coin, realmoney, [rmb])
	local arguments = {...}
	local churrency = 'B'
	local churrency_mark = {'C', 'G', 'Y'}

	for v in ipairs(arguments) do
		if arguments[v] ~= 0 then
			churrency = churrency_mark[v]
		end
	end
	
	if channel_id == 'dongyou' then
		if churrency == 'Y' then
			churrency = 'D'
		end
	end
	return churrency
end
--------------------------------------------------------------------------------------A-D-V-A-N-C-E-D-M-E-T-H-O-D---
--print log
function AM_PringLog(...)
	if flag_print_log == true then
		local arguments = {...}
		local log_str = ''
		for v in ipairs(arguments) do
			log_str = log_str .. arguments[v]
		end
		EGE:LogTrace('LOG_F: ' .. log_str)
	end
end
--show ui with ani unlock screen
function AM_ShowComponent(c_name, ...)--(_uiComponentDisplay, ['UI_TYPE'], [change_delay])
	local arguments = {...}
	
	for v in ipairs(arguments) do
		if v == 1 then
			--ui type
			if arguments[v] == 'UEFF_POP' then
				_uiComponentDisplay.setShowAni(c_name, 'ui_ani_show_popup')
			elseif arguments[v] == 'CEFF_POP' then
				_uiComponentDisplay.setShowAni(c_name, 'ui_ani_show_stagecontinue')
			end
		elseif v == 2 then
			--change delay
			_uiComponentDisplay.setShowAniDelay(c_name, arguments[2])
		end
	end

	if c_name.DFlag then
		c_name.CName:Show(c_name.DFlag)
		--AniPlay
		c_name.CName:PlaySkeletonAnimation(c_name.ShowAniDelay, c_name.ShowAni, true, false)
	else
		--AniFadeOutUnlockScreen
		c_name.CName:FadeOut(0, c_name.HideAniDelay, false, EnumInterpolatorType.Linear)
		c_name.CName:Enable(false)
		--AniPlay
		c_name.CName:PlaySkeletonAnimation(c_name.HideAniDelay, c_name.HideAni, false, true)
	end
end

--set value with symbol or not
function AM_SetComponentValue(component_name, ...)--(component_name, ['symbol'], value)
	local arguments = {...}
	local symbol = false
	
	if arguments[1] == '+' then
		symbol = true
	end

	component_name:SetTextByInteger(arguments[#arguments], symbol)
end

--set progressbar range and value
function AM_SetPGbarValue(component_name, range, front_value, ...)--(component_name, range, front_value, [back_value])
	local arguments = {...}
	local back_value = 0
	
	if #arguments ~= 0 then	
		back_value = arguments[#arguments]
	end
	
	component_name:SetProgressRange(0, range)
	component_name:SetProgressValue(front_value)
	component_name:SetProgressBgValue(back_value)
end

--play sound
function AM_PlaySound(component_name, ...)--(component_name, [delay], [sound_name], [volume])
	local arguments = {...}
	local volume = 0.5;
	local delay = 0;
	local sound_name = 'sfx_ui_click2';

	for v in ipairs(arguments) do
		if v == 1 then
			delay = arguments[v]
		elseif v == 2 then
			sound_name = arguments[v]
		elseif v == 3 then
			volume = arguments[v]
		end
	end	

	component_name:PlaySound(sound_name, sound_name, volume, delay);
end

--play bgm
function AM_PlayBGM(...)--('BGM_NAME', fadeout_time, fadein_time, [volume])
	local arguments = {...}
	local fadeout_time = 500
	local fadein_time = 500
	local volume = 0.5
	
	for v in ipairs(arguments) do
		if v == 1 then
		elseif v == 2 then
			if #arguments == 2 then
				volume = arguments[v]
			else
				fadeout_time = arguments[v]
			end
		elseif v == 3 then
			fadein_time = arguments[v]
		elseif v == 4 then
			volume = arguments[v]
		end
	end
	
	GUIFactory:PlayMusic('bgm', arguments[1], fadeout_time, fadein_time, volume)
end

--set text
function AM_SetComponentText(component_name, ...)--(component_name, 'TEXT1', 'TEXT2', 'TEXT...')
	local arguments = {...}

	for i = 1, #arguments do
		if arguments[i] ~= ' ' then
			component_name:SetBlockText(i - 1, arguments[i])
		end
	end
end
--set text with string index
function AM_GetSTR(...)--(string_index/string, [replacement])
	local arguments = {...}
	local string_temp = (type(arguments[1]) == 'string' and arguments[1]) or StateGarage:GetString(arguments[1]).mValue

	if(#arguments == 2) then
		string_temp = string.gsub(string_temp, '%%s', arguments[2])
	end

	return string_temp
	
end
---A-D-V-A-N-C-E-D-M-E-T-H-O-D--------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------L-U-A-L-O-G-I-C---
--[[
function Logic_and(condition1, condition2)
	if condition1 == true then
		if condition2 == true then
			return true
		else
			return false
		end
	else
		return false
	end
end

function Logic_or(condition1, condition2)
	if condition1 == true then
		return true
	else
		if condition2 == true then
			return true
		else
			return false
		end
	end
end
--]]
function Logic_and(...)
	local arguments = {...}
	
	for v in ipairs(arguments) do
		if arguments[v] == false then
			return false
		end
	end
	
	return true
end

function Logic_or(...)
	local arguments = {...}
	
	for v in ipairs(arguments) do
		if arguments[v] == true then
			return true
		end
	end
	
	return false
end
--------------------------------------------------------------------------------------------------------------------initialize _uiR
function Ini_uiR(ui_name)
	local root = GUIFactory:SearchGUIApplicationByName(ui_name)
	local uiR = _uiComponentDisplay:new()
	_uiComponentDisplay.setCName(uiR, root)
	return root, uiR
end

--------------------------------------------------------------------------------------------------------------------initialize _uiC
function Ini_uiC(ui_name, component_name_str)
	local component = GUIFactory:SearchGUIObjectByName(ui_name, component_name_str)
	local uiC = _uiComponentDisplay:new()
	_uiComponentDisplay.setCName(uiC, component)
	return component, uiC
end

--------------------------------------------------------------------------------------------------------------------initialize component
function IniComponent(ui_name, component_name)
	return GUIFactory:SearchGUIObjectByName(ui_name, component_name)
end

--------------------------------------------------------------------------------------------------------------------get current car info
function GetCurrentCarInfo()
	currentCarID = StateGarage:GetCurrentCarShopItemID();
	return StateGarage:GetCarInfoByShopItemID(currentCarID,0);
end

--------------------------------------------------------------------------------------------------------------------get current car lv 1 info
function GetCurrentCarInfoLevelOne()
	currentCarID = StateGarage:GetCurrentCarShopItemID();
	return StateGarage:GetCarInfoByShopItemID(currentCarID,1);
end

--------------------------------------------------------------------------------------------------------------------get current driver info
function GetCurrentDriverInfo()
	currentDriverID = StateGarage:GetCurrentDriverShopItemId();
	return StateGarage:GetDriverInfoByID(currentDriverID);
end

--------------------------------------------------------------------------------------------------------------------get current driver info
function GetSelectedDriverInfo()
	selectedDriverID = StateGarage:GetSelectedDriverShopItemId();
	return StateGarage:GetDriverInfoByID(selectedDriverID);
end

--------------------------------------------------------------------------------------------------------------------show component
function ShowComponent(component_name)
	component_name:Show(true)
end

function Log_ShowComponent(component_name)
	component_name:Show(true)
	AM_PringLog('LOG_F: show component success')
end

--------------------------------------------------------------------------------------------------------------------hide component
function HideComponent(component_name)
	component_name:Show(false)
end

function Log_HideComponent(component_name)
	component_name:Show(false)
	AM_PringLog('LOG_F: hide component success')
end

--------------------------------------------------------------------------------------------------------------------hid component with ani unlock screen
function HideComponentWithAni(component_name, delay, ani_name)
	component_name:PlaySkeletonAnimation(delay, ani_name, true, true);
end

--------------------------------------------------------------------------------------------------------------------component display config
function DisplayConfig(component_name, display_flag)
	component_name:Show(display_flag)
end

--------------------------------------------------------------------------------------------------------------------component display config by name
function DisplayConfigByCName(c_name)
	c_name.CName:Show(c_name.DFlag)
	c_name.CName:Enable(c_name.EFlag)
end

--------------------------------------------------------------------------------------------------------------------check component
function ClickComponent(component_name)
	component_name:Click();
end

--------------------------------------------------------------------------------------------------------------------uncheck component
function UnCheckComponent(component_name)
	component_name:Check(false);
end

--------------------------------------------------------------------------------------------------------------------uncheck component
function CheckComponent(component_name)
	component_name:Check(true);
end

--------------------------------------------------------------------------------------------------------------------enable component
function EnableComponent(component_name)
	component_name:Enable(true);
end

--------------------------------------------------------------------------------------------------------------------disable component
function DisableComponent(component_name)
	component_name:Enable(false);
end

--------------------------------------------------------------------------------------------------------------------set component offset
function SetComponentOffset(component_name, distance_x, distance_y)
	component_name:SetOffset(distance_x, distance_y);
end

--------------------------------------------------------------------------------------------------------------------set text
function SetComponentText(component_name, text)
	component_name:SetText(text);
end

--------------------------------------------------------------------------------------------------------------------set text block
function SetComponentTextBlock(component_name, block_index, text)
	component_name:SetBlockText( block_index, text );
end

--------------------------------------------------------------------------------------------------------------------set value
function SetComponentValue(component_name, value)
	component_name:SetTextByInteger(value, false);
end

--------------------------------------------------------------------------------------------------------------------set value with symbol
function SetComponentValueWithSymbol(component_name, value)
	component_name:SetTextByInteger(value, true);
end

--------------------------------------------------------------------------------------------------------------------set progressbar range
function SetPGbarRange(component_name, value)
	component_name:SetProgressRange(0, value);
end

--------------------------------------------------------------------------------------------------------------------set front progressbar value
function SetFrontPGbarValue(component_name, value)
	component_name:SetProgressValue(value);
end

--------------------------------------------------------------------------------------------------------------------set back progressbar value
function SetBackPGbarValue(component_name, value)
	component_name:SetProgressBgValue(value);
end

--------------------------------------------------------------------------------------------------------------------set whole progressbar value
function SetWholePGbarValue(component_name, range_value, front_value, back_value)
	component_name:SetProgressRange(0, range_value);
	component_name:SetProgressValue(front_value);
	if back_value == '' then
		component_name:SetProgressBgValue(front_value);
	else
		component_name:SetProgressBgValue(back_value);
	end
end

--------------------------------------------------------------------------------------------------------------------change component pix to grey
function ChangeComponent2Grey(component_name)
	component_name:SetGrey(1);
end

--------------------------------------------------------------------------------------------------------------------change component pix to color
function ChangeComponent2Color(component_name)
	component_name:SetGrey(0);
end

--------------------------------------------------------------------------------------------------------------------replace spx
function ReplaceCurrentSpx(component_name, spx_name, tag)
	component_name:SetCurrentRenderObject('F2DModel', spx_name, tag);
end

--------------------------------------------------------------------------------------------------------------------replace spx by state
function ReplaceSpxByState(component_name, component_state, spx_name, tag)
	component_name:SetRenderObject(component_state, 'F2DModel', spx_name, tag);
end

--------------------------------------------------------------------------------------------------------------------replace spr
function ReplaceCurrentSpr(component_name, spr_name)
	component_name:SetCurrentRenderObject('F2DSprite', spr_name, '');
end

--------------------------------------------------------------------------------------------------------------------replace spr by state
function ReplaceSprByState(component_name, component_state, spr_name)
	component_name:SetRenderObject(component_state, 'F2DSprite', spr_name, '');
end

--------------------------------------------------------------------------------------------------------------------replace button spr by state
function ReplaceButtonRes(component_name, normal_spr_name, focus_spr_name)
	component_name:SetRenderObject(EnumGUIGraphicState.Normal, 'F2DSprite', normal_spr_name, '');
	if focus_spr_name == nil then
		component_name:SetRenderObject(EnumGUIGraphicState.Focus, 'F2DSprite', normal_spr_name, '');
	else
		component_name:SetRenderObject(EnumGUIGraphicState.Focus, 'F2DSprite', focus_spr_name, '');
	end
end

--------------------------------------------------------------------------------------------------------------------animation play
function AniPlay(component_name, delay, ani_name)
	if component_name:IsShow() == 1 then
		component_name:PlaySkeletonAnimation(delay, ani_name, true, false);
	end
end

--------------------------------------------------------------------------------------------------------------------animation play
function AniPlayUnlockScreen(component_name, delay, ani_name)
	if component_name:IsShow() == 1 then
		component_name:PlaySkeletonAnimation(delay, ani_name, false, false);
	end
end

--------------------------------------------------------------------------------------------------------------------animation move x
function AniMoveX(component_name, distance_x, delay, duration)
	component_name:OffsetTo(delay, duration, true, distance_x, 0, EnumInterpolatorType.Linear);
end

--------------------------------------------------------------------------------------------------------------------animation move y
function AniMoveY(component_name, distance_y, delay, duration)
	component_name:OffsetTo(delay, duration, true, 0, distance_y, EnumInterpolatorType.Linear);
end

--------------------------------------------------------------------------------------------------------------------animation fade in
function AniFadeIn(component_name, delay, duration)
	component_name:FadeIn(delay, duration, true, EnumInterpolatorType.Linear);
	component_name:Enable(true);
end

--------------------------------------------------------------------------------------------------------------------animation fade in
function AniFadeInUnlockScreen(component_name, delay, duration)
	component_name:FadeIn(delay, duration, false, EnumInterpolatorType.Linear);
	component_name:Enable(true);
end

--------------------------------------------------------------------------------------------------------------------animation fade out
function AniFadeOut(component_name, delay, duration)
	component_name:FadeOut(delay, duration, true, EnumInterpolatorType.Linear);
	component_name:Enable(false);
end

--------------------------------------------------------------------------------------------------------------------animation fade out
function AniFadeOutUnlockScreen(component_name, delay, duration)
	component_name:FadeOut(delay, duration, false, EnumInterpolatorType.Linear);
	component_name:Enable(false);
end

--------------------------------------------------------------------------------------------------------------------play sound
function PlaySound(component_name, sound_name, delay, volume)
	component_name:Show(true);
	component_name:PlaySound(sound_name, sound_name, volume, delay);
end

--------------------------------------------------------------------------------------------------------------------release package texture
function ReleaseUIPackageTexture(package_name)
	ReleasePackageTexture(package_name)
end